# @package      hubzero-submit-common
# @file         ParameterTemplate.py
# @copyright    Copyright (c) 2012-2020 The Regents of the University of California.
# @license      http://opensource.org/licenses/MIT MIT
#
# Copyright (c) 2012-2020 The Regents of the University of California.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# HUBzero is a registered trademark of The Regents of the University of California.
#
from string import Template

class ParameterTemplate(Template):
   """
   Define parameter template for submit command line specification
   """
   delimiter = "@@"
   # it should be noted that an implicit re.IGNORECASE comparsion
   # is made when looking for template key strings
   idpattern = "[a-zA-Z0-9_]+"


   def substitute_recur(self, *args, **kws):
      ss = self.substitute(*args, **kws)
      while (ss != self.template) and (self.delimiter in ss):
         self.template = ss
         ss = self.substitute(*args, **kws)

      return(ss)


   def safe_substitute_recur(self, *args, **kws):
      ss = self.safe_substitute(*args, **kws)
      while (ss != self.template) and (self.delimiter in ss):
         self.template = ss
         ss = self.safe_substitute(*args, **kws)

      return(ss)


